Attribute VB_Name = "Module1"
Option Explicit

Public fso As New FileSystemObject
Public lngTotNbrFolders As Long        'Total # of Folders (global)
Public lngTotNbrFiles As Long          'Total # of Files   (global)
Dim collFilesFound As New Collection   'Collection of Files/Filenames
Dim collFoldersFound As New Collection 'Collection of Folders
Dim collFileMD5 As New Collection      'Collection of MD5 Hashes of Files
Dim collFileCRC32 As New Collection    'Collection of CRC32 Hashes of Files
Dim collDuplicates As New Collection   'Collection of Duplicates
Dim collExcludedExt As New Collection  'Collection of File Extensions to Exclude from Scan
Dim collExcludedFilenames As New Collection 'Collection of Filenames to Exclude from Scan

Public lngTotNbrBytes As Long          'Total # bytes scanned/1000
Public dblTotNbrBytes As Double        'Total # bytes scanned
Public boolCancelFlag As Boolean       'User pressed Cancel button
Public boolBusyProcessing As Boolean   'Currently in the middle of a procedure
Public boolFirstRecordOnGrid As Boolean 'Flag Set to 0 if the grid has 0 Rows
Public lngNbrDuplicates As Long        'Index to List of Duplicate Filenames
Public lngFileLength As Long           '# of bytes in current file
Public m_cIni As New cInifile          'Instance of INI class
Public Type FileHashType               'Type Declaration to ease parameter passing
    Filename As String
    Hash As String
End Type


Public Sub CountFolders(fsoCurFolder As Folder)
'
'   This procedure Parses the directory tree and counts the number of
'     files and folders as well as the total # of bytes contained in those
'     files.  These figures are used to estimate the time for comparing
'     all of the files and for setting the progress bars appropriately.
'
'   This procedure calls itself recursively
'
Dim fsoFolders As Folders
Dim fsoFiles As Files
Dim fsoCurFile As File
On Error GoTo ERROR_LABEL

 If boolCancelFlag = True Then
   Exit Sub
 End If
    
    Set fsoFolders = fsoCurFolder.SubFolders
    Set fsoFiles = fsoCurFolder.Files
'    lngTotNbrFiles = lngTotNbrFiles + fsoFiles.count
    frmMain.lblNbrFiles.Caption = lngTotNbrFiles
    
    If fsoFiles.count <> 0 Then
        For Each fsoCurFile In fsoFiles
          If (Not (ExcludeFile(fsoCurFile.Name))) Then
            If ((fsoCurFile.Attributes And vbHidden) <> vbHidden And _
                (fsoCurFile.Attributes And vbSystem) <> vbSystem) Then 'exclude sys/hid
              lngTotNbrFiles = lngTotNbrFiles + 1
              dblTotNbrBytes = dblTotNbrBytes + fsoCurFile.Size
            End If
          End If
        Next
    End If
    
    If fsoFolders.count = 0 Then
        Exit Sub
    Else
        For Each fsoCurFolder In fsoFolders
            lngTotNbrFolders = lngTotNbrFolders + 1
            frmMain.lblNbrFolders.Caption = lngTotNbrFolders
            frmMain.lblFolderPath.Caption = fsoCurFolder.Path
            Call CountFolders(fsoCurFolder)
        Next
    End If
    DoEvents
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "CountFolders"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Sub FindDuplicatedFiles(strInDir As String)
Dim varTemp As Variant
Dim fsoFolder As Folder
Dim fsoFile As File
Dim fsoFile2 As File
Dim intFileToCheck, intFileToCheckAgainst As Integer
Dim i As Long
Dim strTempCRC32 As String
Dim tmpEntry As FileHashType
Dim lngHowFarAlong As Long
Dim dblHowFarAlong As Double
Dim tmpName As String
On Error GoTo ERROR_LABEL
    Set fsoFolder = fso.GetFolder(strInDir)
    collFoldersFound.Add fsoFolder.Path
'       Get All Folders and SubFolders beneath srtInDir
    Call GrabFoldersFromFolder(fsoFolder)
'       Get All Files from the above folders
    For i = 1 To collFoldersFound.count
        Call GrabFilesFromFolder(collFoldersFound.Item(i))
    Next i
'
'       Setup FlexGrid Column Headers
'
    With frmDisplayDuplicates.MSFlexGrid1
        .Row = 0
        .Col = 0
        .Rows = 1  'We add 1 to ensure we get all the rows
        .Cols = 5
        .ColWidth(0) = 1440 * 0.5   ' # column
        .ColWidth(1) = 250          ' CheckBox column
        .ColWidth(2) = 1440 * 0.75  ' Hash/Size column
        .ColWidth(3) = 1440 * 1     ' Filename column
        .ColWidth(4) = 1440 * 7     ' Path column
        '
        .TextMatrix(0, 0) = "Dup #"
        .TextMatrix(0, 1) = ""
        .TextMatrix(0, 2) = "Hash/Size"
        .TextMatrix(0, 3) = "FileName"
        .TextMatrix(0, 4) = "Path"
        .AllowUserResizing = flexResizeColumns
        .GridLines = flexGridNone
    End With
        
    'Debug.Print "Found: " & collFilesFound.count
    frmMain.pbarThisFile.Min = 0
    frmMain.pbarThisFile.Max = 100
            
    For intFileToCheck = 1 To collFilesFound.count
        boolBusyProcessing = True
        If boolCancelFlag Then
          ResetForm
          EmptyCollections
          Exit Sub
        End If
        frmMain.pbarThisFile.Value = 0
        tmpName = collFilesFound.Item(intFileToCheck)
        Set fsoFile2 = fso.GetFile(tmpName)
        lngFileLength = fsoFile2.Size
        strTempCRC32 = CalcFileCRC32(tmpName)
        dblHowFarAlong = dblHowFarAlong + lngFileLength
        lngHowFarAlong = (dblHowFarAlong / dblTotNbrBytes) * 100
        frmMain.ProgressBar1.Value = lngHowFarAlong
        collFileCRC32.Add strTempCRC32
        tmpEntry.Filename = tmpName
        tmpEntry.Hash = strTempCRC32
        AddToDuplicateList tmpEntry
    Next intFileToCheck
    boolFirstRecordOnGrid = True
    FillDuplicateForm
            
    frmMain.lblStatus.Caption = "Duplicate Scan Complete!"
    frmMain.cmdStartSearch.Enabled = True
    frmMain.lblNbrFolders.Caption = "Complete"
    frmMain.cmdCancel.Enabled = False
    GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "FindDuplicatedFiles"
  Resume PROCEDURE_EXIT
  FillDuplicateForm
PROCEDURE_EXIT:
End Sub


Sub GrabFilesFromFolder(strDir As String)
'
'  Retrieves all Filenames within the supplied folder strDir
'       and stores them in collFilesFound
'
Dim lFile As File
Dim lFiles As Files
Dim fsoFolder As Folder
Dim strTemp As String

On Error GoTo ERROR_LABEL
    Set fsoFolder = fso.GetFolder(strDir)
    Set lFiles = fsoFolder.Files
    For Each lFile In lFiles
        strTemp = lFile.Path
        If ((lFile.Attributes And vbHidden) <> vbHidden And _
            (lFile.Attributes And vbSystem) <> vbSystem) Then 'exclude sys/hid
          If (Not (ExcludeFile(strTemp))) Then
            collFilesFound.Add lFile.Path
          End If
        End If
    Next
    DoEvents
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "GrabFilesFromFolder"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub

Sub GrabFoldersFromFolder(fsoFolder As Folder)
'
'  Retrieves all Folders within the supplied folder fsoFolder (Recursively)
'       and stores them in collFoldersFound
'
Dim lFolders As Folders
On Error GoTo ERROR_LABEL
    Set lFolders = fsoFolder.SubFolders
    If lFolders.count = 0 Then
        Exit Sub
    Else
        For Each fsoFolder In lFolders
            collFoldersFound.Add fsoFolder.Path
            Call GrabFoldersFromFolder(fsoFolder)
        Next
    End If
    DoEvents
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "GrabFoldersFromFolder"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Public Function CalcFileCRC32(strFilename As String) As String
Dim cCRC32 As New cCRC32
Dim lCRC32 As Long
Dim cStream As New cBinaryFileStream
On Error GoTo ERROR_LABEL
   cStream.File = strFilename
   lCRC32 = cCRC32.GetFileCrc32(cStream)
   CalcFileCRC32 = Hex(lCRC32)
   lngFileLength = cStream.Length
   DoEvents
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "CalcFileCRC32"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Function



Public Sub AddToDuplicateList(EntryIn As FileHashType)
On Error GoTo ERROR_LABEL
Dim TempEntry As FileHashType
Dim arrTemp(2) As String

arrTemp(1) = EntryIn.Filename
arrTemp(2) = EntryIn.Hash

Dim collFileNames As Collection
Set collFileNames = New Collection
collFileNames.Add arrTemp
'
'   If you get an error below, it means that the same File Hash has already
'     been added - i.e. this is a duplicate file
'
On Error GoTo DUPLICATE_LABEL
collDuplicates.Add collFileNames, Key:=EntryIn.Hash
On Error GoTo ERROR_LABEL
GoTo PROCEDURE_EXIT

DUPLICATE_LABEL:
collDuplicates.Item(EntryIn.Hash).Add arrTemp
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "AddToDuplicateList"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
Set collFileNames = Nothing
End Sub


Sub FillDuplicateForm()
Dim strTemp As String
Dim x, y As Long
Dim boolAddedFilename As Boolean
Dim collTempCollection As Collection
Dim strTemp2 As String
Dim varTempVar As Variant
Dim varTemp2 As FileHashType
Dim arrTemp(2) As String
On Error GoTo ERROR_LABEL2

strTemp = ""
For y = 1 To collDuplicates.count
  If collDuplicates.Item(y).count > 1 Then
      Set collTempCollection = collDuplicates.Item(y)
      arrTemp(1) = collDuplicates.Item(y).Item(1)(1)
      arrTemp(2) = collDuplicates.Item(y).Item(1)(2)
      strTemp2 = arrTemp(1)
      AddRecordToGrid collDuplicates.Item(y)
  End If
Next
DoEvents
'collDuplicates.Item(EntryIn.Hash).Add arrTemp
GoTo PROCEDURE_EXIT
ERROR_LABEL2:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "FillDuplicateForm"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Public Sub AddRecordToGrid(collDupes As Collection)
'
'   When called once, this routine adds 1 collection of identical files to
'       the MSFlexGrid control on frmDisplayDuplicates
'
Dim i As Integer
Dim lngRowNbr As Long
Dim strFilename, strPath, strTemp(2) As String
Dim tmpEntry As FileHashType
On Error GoTo ERROR_LABEL

If (Not (boolFirstRecordOnGrid)) Then
    AddDividerToGrid
End If
boolFirstRecordOnGrid = False
For i = 1 To collDupes.count
     With frmDisplayDuplicates.MSFlexGrid1
          lngRowNbr = .Rows + 1
          .Rows = lngRowNbr
          lngNbrDuplicates = lngNbrDuplicates + 1
          .Row = lngRowNbr - 1
          .Col = 0
          .TextMatrix(.Row, 0) = lngNbrDuplicates
          .Col = 1
          .CellPictureAlignment = 4
    '  Don't flag the first of each set for deletion
          If i = 1 Then
             Set .CellPicture = frmDisplayDuplicates.picUnchecked.Picture  ' Don't check the first file
            Else
             Set .CellPicture = frmDisplayDuplicates.picChecked.Picture  ' Check all of the duplicates
          End If
          tmpEntry.Filename = collDupes.Item(i)(1)
          tmpEntry.Hash = collDupes.Item(i)(2)
          strPath = getPath(tmpEntry.Filename)
          strFilename = getFileName(tmpEntry.Filename, Len(strPath))
          
          .TextMatrix(lngRowNbr - 1, 2) = tmpEntry.Hash
          .TextMatrix(lngRowNbr - 1, 3) = strFilename
          .TextMatrix(lngRowNbr - 1, 4) = strPath
          .Row = lngRowNbr - 1
          .Col = 2
          .CellAlignment = flexAlignLeftCenter
     End With
Next
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "AddRecordToGrid"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Public Sub AddDividerToGrid()
Dim lngRowNbr As Long
Dim i As Integer
On Error GoTo ERROR_LABEL

With frmDisplayDuplicates.MSFlexGrid1
  lngRowNbr = .Rows + 1
  .Rows = lngRowNbr
  .RowHeight(lngRowNbr - 1) = 120
  .Row = lngRowNbr - 1
  For i = 0 To .Cols - 1
    .Col = i
    .CellBackColor = &HD9E9E9
  Next
End With
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "AddDividerToGrid"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Private Function getPath(fullPath As String) As String
Dim tempFile As Variant
Dim tempPath As Variant
On Error GoTo ERROR_LABEL
  tempFile = Dir(fullPath)

  '//retrieve the path only
  tempPath = Left(fullPath, Len(fullPath) - Len(tempFile))

  '//now, make sure that the last charactor is a "\"
  If Right(tempPath, 1) = "\" Then
    getPath = tempPath '//no need to add "\",already has this charactor
  Else
    '//add the character at the end
    getPath = tempPath & "\"
  End If
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "getPath"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Function


Private Function getFileName(fullPath As String, lngPathLength As Long) As String
Dim tempFile As String
Dim lngFilenameLength As Long
On Error GoTo ERROR_LABEL
  lngFilenameLength = Len(fullPath) - lngPathLength
  If lngFilenameLength < 1 Then
    lngFilenameLength = Len(fullPath)
    getFileName = fullPath
   Else
    getFileName = Right(fullPath, lngFilenameLength)
  End If
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "getFileName"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Function


Public Sub EmptyCollections()
On Error GoTo ERROR_LABEL
Set collFilesFound = Nothing
Set collFoldersFound = Nothing
Set collFileMD5 = Nothing
Set collFileCRC32 = Nothing
Set collDuplicates = Nothing
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "EmptyCollections"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Private Sub CreateIniFile()
Dim i As Long
Dim iNd As Long
    On Error Resume Next
        Kill App.Path & "\" & App.Title & ".INI"
    On Error GoTo ERROR_LABEL
    With m_cIni
        .Path = App.Path & "\" & App.Title & ".INI"
        .Section = "Window"
        .Key = "Left"
        .Value = frmMain.Left
        .Key = "Top"
        .Value = frmMain.Top
        .Key = "Width"
        .Value = frmMain.Width
        .Key = "Height"
        .Value = frmMain.Height
    End With
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "CreateINIFile"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Private Sub ReadINIFile()
Dim fso As New FileSystemObject
On Error GoTo ERROR_LABEL
If fso.FileExists(App.Path & "\" & App.Title & ".INI") = False Then
  CreateIniFile
End If

GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "ReadINIFile"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Private Function ExcludeFile(strInFile As String) As Boolean
Dim boolTemp As Boolean
Dim strExt As String
Dim strPath As String
Dim strFilename As String
Dim intExtPos As Integer
Dim intIndex As Integer
On Error GoTo ERROR_LABEL

   strFilename = strInFile
   intExtPos = InStrRev(strFilename, ".", -1, vbTextCompare)
   strExt = Right(strFilename, Len(strFilename) - intExtPos)
   boolTemp = False
   If strExt <> "" Then
     For intIndex = 1 To collExcludedExt.count
       If StrComp(collExcludedExt.Item(intIndex), strExt, vbTextCompare) = 0 Then
          boolTemp = True
          Exit For
       End If
     Next
   End If
     If Not boolTemp Then
       For intIndex = 1 To collExcludedFilenames.count
         If StrComp(collExcludedFilenames.Item(intIndex), strFilename, vbTextCompare) = 0 Then
            boolTemp = True
            Exit For
         End If
       Next
     End If
ExcludeFile = boolTemp
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "Function ExcludeFile"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Function


Public Sub AddToExclusions(strExt As String, strFilename As String)
Dim strTemp1, strTemp2 As String
Dim intPosition As Integer
On Error GoTo ERROR_LABEL
Set collExcludedExt = Nothing
Set collExcludedFilenames = Nothing

  strTemp1 = Replace(strExt, vbCrLf, "|", 1, -1, vbTextCompare) & "|"
  While (InStr(1, strTemp1, "|", vbTextCompare) <> 0)
    intPosition = InStr(1, strTemp1, "|", vbTextCompare)
    strTemp2 = Trim$(Left(strTemp1, intPosition - 1))
    strTemp1 = Right(strTemp1, Len(strTemp1) - intPosition)
    If strTemp2 <> "" Then
      collExcludedExt.Add strTemp2
    End If
  Wend

  strTemp1 = Replace(strFilename, vbCrLf, "|", 1, -1, vbTextCompare) & "|"
  While (InStr(1, strTemp1, "|", vbTextCompare) <> 0)
    intPosition = InStr(1, strTemp1, "|", vbTextCompare)
    strTemp2 = Trim$(Left(strTemp1, intPosition - 1))
    strTemp1 = Right(strTemp1, Len(strTemp1) - intPosition)
    If strTemp2 <> "" Then
      collExcludedFilenames.Add strTemp2
    End If
  Wend
  AddExclusionsToINI

GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "AddToExclusions"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Public Sub LoadExclusions()
Dim i As Integer
Dim strTemp As String
On Error GoTo ERROR_LABEL

LoadExclusionsFromINI
  strTemp = ""
  For i = 1 To collExcludedExt.count
    If i <> 1 Then
      strTemp = strTemp & vbCrLf
    End If
    strTemp = strTemp + collExcludedExt.Item(i)
  Next
  frmExceptions.txtExtensions.Text = strTemp
  strTemp = ""
  For i = 1 To collExcludedFilenames.count
    If i <> 1 Then
      strTemp = strTemp & vbCrLf
    End If
    strTemp = strTemp + collExcludedFilenames.Item(i)
  Next
  frmExceptions.txtFilenames.Text = strTemp

GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "LoadExclusions"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Public Sub AddExclusionsToINI()
Dim strINIFilename As String
Dim strKeyName As String
Dim i As Integer
On Error GoTo ERROR_LABEL
strINIFilename = App.Path & "\" & App.Title & ".INI"

    With m_cIni
        .Path = strINIFilename
        .Section = "ExcludedExtensions"
        .DeleteSection
        For i = 1 To collExcludedExt.count
          .Key = "Ext" & i
          .Value = collExcludedExt.Item(i)
        Next
        .Path = strINIFilename
        .Section = "ExcludedFilenames"
        .DeleteSection
        For i = 1 To collExcludedFilenames.count
          .Key = "Filename" & i
          .Value = collExcludedFilenames.Item(i)
        Next
    End With

GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "AddExclusionsToINI"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub


Public Sub LoadExclusionsFromINI()
Dim strINIFilename As String
Dim strKeyName As String
Dim sKey() As String, iCount As Long, i As Long
Dim sKey2() As String, iCount2 As Long, i2 As Long
On Error GoTo ERROR_LABEL

strINIFilename = App.Path & "\" & App.Title & ".INI"
Set collExcludedExt = Nothing
Set collExcludedFilenames = Nothing

    With m_cIni
        .Path = strINIFilename
        .Section = "ExcludedExtensions"
        .EnumerateCurrentSection sKey(), iCount
         For i = 1 To iCount
           .Key = sKey(i)
           collExcludedExt.Add .Value
         Next i
    End With

    With m_cIni
        .Path = strINIFilename
        .Section = "ExcludedFilenames"
        .EnumerateCurrentSection sKey2(), iCount2
         For i2 = 1 To iCount2
           .Key = sKey2(i2)
           collExcludedFilenames.Add .Value
         Next i2
    End With
GoTo PROCEDURE_EXIT
ERROR_LABEL:
  MsgBox "Error: " & Err.Number & ". " & Err.Description, , "LoadExclusionsFromINI"
  Resume PROCEDURE_EXIT
PROCEDURE_EXIT:
End Sub
 
Sub ResetForm()
'   Initialize Main form and controls
  With frmMain
     .cmdStartSearch.Enabled = False
     .Dir1.Path = ""
     .cmdScanFolder.Enabled = True
     .Label1.Caption = ""
     .Label4.Caption = ""
     .lblFolderPath.Caption = ""
     .lblStatus.Caption = ""
     .lblNbrFolders.Caption = ""
     .lblNbrFiles.Caption = ""
     .cmdStartSearch.Enabled = False
     .Frame1.Enabled = False
     .ProgressBar1.Visible = False
     .pbarThisFile.Visible = False
     .lblThisFile.Visible = False
     .lblAllFiles.Visible = False
     .cmdCancel.Enabled = False
   End With
   boolBusyProcessing = False
End Sub
